//+-------------------------------------------+
//|      Bulldozer_A12_v2.6Magic_No_Error.mq4 |
//|                  Copyright  2010, ir0407 |
//|                    Edited by skumen, 2011 |
//|                    Edited by al22bag 2012 |
//+-------------------------------------------+
#property copyright "Copyright  2010, ir0407"
#property link      "wlmaster@mail.ru"
#include <stderror.mqh>
#include <stdlib.mqh>
//-------------------------------------
//=================================================================================================================
//  05.06.2012    Magic      !--- --  "skumen"
//  10.06.2012      "schtoff"      ------""
//=================================================================================================================
extern string GenSet             = "General Settings";
extern bool   Debug              = True;
extern bool   Sound              = True;
extern int    MN                 = 1;     // Magic
extern int    MaxTrades          = 5;     //       ( )
extern int    MaxOpenOrders      = 3;     //         
extern int    ProfitClose_On_Off = 0;     //         
//-------------------------------------
extern string LotSet             = "Lot Settings";
extern double InitLot            = 0.01;  //     
extern int    LotDecimal         = 2;     //      
extern double LotExp             = 2;     //        , :   0.1, : 0.16, 0.26, 0.43 ...
extern double MaxLot             = 5;     //  
extern int    StartOppLot        = 3;     //  o      
extern double OppLotExp          = 0.5;   //        
//-------------------------------------
extern string StepSet            = "PipStep Settings";
extern int    InitPipStep        = 100;
extern int    PipStepMode        = 1;     // 0 - , 1- A
extern double PipStepExp         = 1;     //   ,     1
extern int    PipStepInc         = 0;     //   ,     0
extern int    StartDynStep       = 3;     //     
//-------------------------------------
extern string SigSet             = "Signals Settings";
extern bool   ManualFirstOrder   = False; // ! True,  !  
extern double PriceDistance      = 300;   //        
extern int    Recoil             = 30;    //    %%  PriceDistance
extern int    NumberOfBars       = 15;    //   
extern int    TF_Bars            = 1;     // 0-   , 1-M1, 2-M5, 3-M15, 4-M30, 5-H1, 6-H4, 7-D1, 8-W1, 9-MN
//-------------------------------------
string   ExpertName = "Bulldozer_A12_v2.6";
datetime NewBarOpenTime;
double   LastTickTime;
int      Slippage, Error = 0, TakeProfit;
int      mper[10] = {0,1,5,15,30,60,240,1440,10080,43200};

// ----- EA initialization function -----
int init()
{
//  NewBarOpenTime = Time[0];
  return(0);
}
// ----- EA deinitialization function -----
int deinit()
{
  return(0);
}
// ----- EA start function -----
int start()
{
  int    Signal, Ticket;
  int    TotalOrders, BuyOrders, SellOrders;
  int    PipStepBuy, PipStepSell;
  double NewLotBuy, NewLotSell, TotalLots;
  double BuyProfit, SellProfit, ProfitPips;
  double LastBuyPrice, LastSellPrice, NewTPPrice;

  //   ,      
  if(NewBarOpenTime == Time[0]) return(0);   //   

  //    ,       
  NewBarOpenTime = Time[0];
  LastTickTime = MarketInfo(Symbol(),MODE_TIME);
  Slippage = MarketInfo(Symbol(), MODE_SPREAD);
  if(ManualFirstOrder) MN = 0;
  TakeProfit = Recoil * PriceDistance / 100;
  TotalOrders = CountOfOrders();
  //------------------
  if(TotalOrders == 0) //     
  { 
    Signal = GetSignal();
    //Signal = GetSignal(0, NumberOfBars);
    switch(Signal)
    { 
      case 1: //  
        if(Debug) Print("TotalOrders = 0, Signal: BUY, Sending 1st BUY order...");
        Ticket = SendMarketOrder(OP_BUY, InitLot, 0, 0, MN, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        if(Ticket > 0)
          if(OrderSelect(Ticket, SELECT_BY_TICKET))
          {
            if(ProfitClose_On_Off == 0)
            {
              NewTPPrice = OrderOpenPrice() + (TakeProfit * Point);
              ModifyOrder(NewTPPrice);
              if(Sound) PlaySound("OpenOrder.wav");
            }
          }
        break;
      case -1: //  
        if(Debug) Print("TotalOrders = 0, Signal: SELL, Sending 1st SELL order...");
        Ticket = SendMarketOrder(OP_SELL, InitLot, 0, 0, MN, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        if(Ticket > 0)
          if(OrderSelect(Ticket, SELECT_BY_TICKET))
          {
            if(ProfitClose_On_Off == 0)
            {
              NewTPPrice = OrderOpenPrice() - (TakeProfit * Point);
              ModifyOrder(NewTPPrice);
              if(Sound) PlaySound("OpenOrder.wav");
            }
          }
        break;
      default:
        //if(Debug) Print("Signal = ",Signal,", waiting for new bar...");
        break;
    }//exit switch(Signal)
    return(0);
  }//exit if(TotalOrders == 0)
  //------------------------------------------
  if(TotalOrders > 0) //        
  { 
    //---       ,   ---
    if(ProfitClose_On_Off == 1)
    {
      TotalLots = MathAbs(CalcLotsBuy() - CalcLotsSell());
      if(TotalLots > 0) 
      {
        ProfitPips = NormalizeDouble(((CalcBuyProfit() + CalcSellProfit()) / (Point * TotalLots)),0);
        if(ProfitPips >= TakeProfit) 
        {
          if(Sound) PlaySound("TakeProfit.wav");
          CloseSymbol(); 
        }
      }
    }//exit if(ProfitClose_On_Off == 1)
    //---    ---
    BuyOrders = CountOfBuy();
    if(BuyOrders > MaxOpenOrders)
    {
      CloseFirstOrderBuy();
      if(Sound) PlaySound("CloseOrder.wav");
      RecalculateTP(OP_BUY);
      BuyOrders = CountOfBuy();
    }
    SellOrders = CountOfSell();
    if(SellOrders > MaxOpenOrders)
    {
      CloseFirstOrderSell();
      if(Sound) PlaySound("CloseOrder.wav");
      RecalculateTP(OP_SELL);
      SellOrders = CountOfSell();
    }
    //----------------
    if(BuyOrders == 0)
    {
      if(ManualFirstOrder) Print("Waiting for Manual BUY Order");
      if(!(ManualFirstOrder))
      {
        if(Signal != 1)
          if(SellOrders >= StartOppLot)
            Signal = 1;
        if(Signal == 1)
        {
          if(SellOrders < StartOppLot)
          {
            NewLotBuy = InitLot;
            if(Debug) Print("Sending 1st BUY order, InitLot = ",NewLotBuy);
          }
          if(SellOrders >= StartOppLot)
          { 
            NewLotBuy = NormalizeDouble(FindLastLotSell() * OppLotExp, LotDecimal);
            if(NewLotBuy < InitLot) NewLotBuy = InitLot;
            if(NewLotBuy > MaxLot)  NewLotBuy = MaxLot;
            if(Debug) Print("Sending 1st BUY order, OppLot = ",NewLotBuy);
          }      
          Ticket = SendMarketOrder(OP_BUY, NewLotBuy, 0, 0, MN, ExpertName + "-" + (BuyOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              if(ProfitClose_On_Off == 0)
              {
                NewTPPrice = OrderOpenPrice() + (TakeProfit * Point);
                ModifyOrder(NewTPPrice);
                if(Sound) PlaySound("OpenOrder.wav");
              }
            }
        }//exit if(Signal == 1)
      }//exit if(!(ManualFirstOrder))
    }//exit if(BuyOrders == 0)
    //----------------
    if(SellOrders == 0)
    {
      if(ManualFirstOrder) Print("Waiting for Manual SELL Order");
      if(!(ManualFirstOrder))
      {
        if(Signal != -1)
          if(BuyOrders >= StartOppLot)
            Signal = -1;
        if(Signal == -1)
        {
          if(BuyOrders < StartOppLot)
          {
            NewLotSell = InitLot;
            if(Debug) Print("Sending 1st SELL order, InitLot = ",NewLotSell);
          }
          if(BuyOrders >= StartOppLot)
          { 
            NewLotSell = NormalizeDouble(FindLastLotBuy() * OppLotExp, LotDecimal);
            if(NewLotSell < InitLot) NewLotSell = InitLot;
            if(NewLotSell > MaxLot)  NewLotSell = MaxLot;
            if(Debug) Print("Sending 1st SELL order, OppLot = ",NewLotSell);
          }      
          Ticket = SendMarketOrder(OP_SELL, NewLotSell, 0, 0, MN, ExpertName + "-" + (SellOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              if(ProfitClose_On_Off == 0)
              {
                NewTPPrice = OrderOpenPrice() - (TakeProfit * Point);
                ModifyOrder(NewTPPrice);
                if(Sound) PlaySound("OpenOrder.wav");
              }
            }
        }//exit if(Signal == 1)
      }//exit if(!(ManualFirstOrder))
    }//exit if(SellOrders == 0)
    //---------------
    if(BuyOrders > 0)
    { 
      //RecalculateTP(OP_BUY);
      LastBuyPrice = FindLastBuyPrice();
      //-----    -----
      if(BuyOrders < StartDynStep) PipStepBuy = InitPipStep;
      if(BuyOrders >= StartDynStep)
      {
        if(PipStepMode == 0) //Geom
          PipStepBuy = NormalizeDouble(InitPipStep * MathPow(PipStepExp,(BuyOrders-StartDynStep+1)),0);
        if(PipStepMode == 1) //Arith
          PipStepBuy = InitPipStep + (PipStepInc * (BuyOrders-StartDynStep));
      }
      //-------------------------------------------
      if(Ask < LastBuyPrice - (PipStepBuy * Point)) //     PipStepBuy
      { 
        if(BuyOrders < MaxTrades)
        {
          //-----    -----
          NewLotBuy = NormalizeDouble(InitLot * MathPow(LotExp, BuyOrders), LotDecimal);
          //NewLotBuy = NormalizeDouble(FindLastLotBuy() * LotExp, LotDecimal);
          if(NewLotBuy > MaxLot) NewLotBuy = MaxLot;
          //----------------------------------
          if(Debug) Print("Sending BUY Order Number ",BuyOrders + 1,", NewLotBuy = ",NewLotBuy);
          Ticket = SendMarketOrder(OP_BUY, NewLotBuy, 0, 0, MN, ExpertName + "-" + (BuyOrders + 1) + "-" + DoubleToStr((LastBuyPrice - Ask) / Point, 0), Error);
          if((Ticket > 0) && (ProfitClose_On_Off == 0))
          { 
            if(Sound) PlaySound("NewStepOrder.wav");
            NewTPPrice = NormalizeDouble(CalculateAveragePriceBuy() + (TakeProfit * Point), Digits);
            if(Debug) Print("LastTP Off, Modifying all BUY orders");
            for(int i1 = 0; i1 < OrdersTotal(); i1++) 
              if(OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
                if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN)
                  if(OrderType()== OP_BUY) 
                    ModifyOrder(NewTPPrice);
          }//exit if(Ticket > 0)
        }//exit if(BuyOrders < MaxTrades)
      }//exit if(Ask < LastBuyPrice - (PipStepBuy * Point))
    }//exit if(BuyOrders > 0)
    //----------------
    if(SellOrders > 0)
    {     
      //RecalculateTP(OP_SELL);
      LastSellPrice = FindLastSellPrice();
      //-----    -----
      if(SellOrders < StartDynStep) PipStepSell = InitPipStep;
      if(SellOrders >= StartDynStep)
      {
        if(PipStepMode == 0) //Geom
          PipStepSell = NormalizeDouble(InitPipStep * MathPow(PipStepExp,(SellOrders-StartDynStep+1)),0);
        if(PipStepMode == 1) //Arith
          PipStepSell = InitPipStep + (PipStepInc * (SellOrders-StartDynStep));
      }
      //---------------------------------------------
      if(Bid > LastSellPrice + (PipStepSell * Point)) //     PipStepSell
      {   
        if(SellOrders < MaxTrades)
        {
          //-----    -----
          NewLotSell = NormalizeDouble(InitLot * MathPow(LotExp, SellOrders), LotDecimal);
          //NewLotSell = NormalizeDouble(FindLastLotSell() * LotExp, LotDecimal);
          if(NewLotSell > MaxLot) NewLotSell = MaxLot;
          //----------------------------------
          if(Debug) Print("Sending SELL Order Number ",SellOrders + 1,", NewLotSell = ",NewLotSell);
          Ticket = SendMarketOrder(OP_SELL, NewLotSell, 0, 0, MN, ExpertName + "-" + (SellOrders + 1) + "-" + DoubleToStr((Bid - LastSellPrice) / Point, 0), Error);
          if((Ticket > 0) && (ProfitClose_On_Off == 0))
          { 
            if(Sound) PlaySound("NewStepOrder.wav");
            NewTPPrice = NormalizeDouble(CalculateAveragePriceSell() - (TakeProfit * Point), Digits);
            if(Debug) Print("LastTP Off, Modifying all SELL orders");
            for(int i2 = 0; i2 < OrdersTotal(); i2++) 
              if(OrderSelect(i2, SELECT_BY_POS, MODE_TRADES))
                if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN)
                  if(OrderType()== OP_SELL) 
                    ModifyOrder(NewTPPrice);
          }//exit if(Ticket > 0)
        }//exit if(SellOrders < MaxTrades)
      }//exit if(Bid > LastSellPrice + (PipStepSell * Point))
    }//exit if(SellOrders > 0)
  }//exit if(TotalOrders > 0)
  return(0);
}// exit start function
//--------------
int CountOfOrders()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if((OrderType() == OP_BUY) || (OrderType() == OP_SELL)) 
            count++;
  return(count);
}
//--------------
int CountOfBuy()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType() == OP_BUY) 
            count++;
  return(count);
}
//---------------
int CountOfSell()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType() == OP_SELL) 
            count++;
  return(count);
}
//------------------
double CalcLotsBuy()
{
  double lots = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_BUY) 
            lots += OrderLots();
  return(lots);
}
//-------------------
double CalcLotsSell()
{
  double lots = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_SELL) 
            lots += OrderLots();
  return(lots);
}
//--------------------
double CalcBuyProfit()
{
  double profit = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_BUY) 
            profit += OrderProfit();
  return(profit);
}
//---------------------
double CalcSellProfit()
{
  double profit = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_SELL) 
            profit += OrderProfit();
  return(profit);
}
//----------------
void CloseSymbol()
{
  bool Result;
  for(int i = OrdersTotal() - 1; i >= 0; i--) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
      if(OrderSymbol()==Symbol()) 
        if((OrderType()==OP_BUY) || (OrderType()==OP_SELL))
          if(OrderMagicNumber() == MN)
          { 
            RefreshRates();
            if(OrderType()==OP_BUY) 
              Result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,CLR_NONE);
            if(OrderType()==OP_SELL)
              Result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,CLR_NONE);
            if(Result!=true) 
            { 
              Error=GetLastError(); 
              Print("CloseSymbol LastError = ",Error); 
            }
            else Error=0;
          }
  return;
}
//-----------------------
void CloseFirstOrderBuy()
{
  bool Result;
  int  ticket = 0;

  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_BUY)
            if(ticket == 0)
            {
              ticket = OrderTicket();
              continue;
            }
            if(OrderTicket() < ticket)
              ticket = OrderTicket();
  RefreshRates();
  Result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),Slippage,CLR_NONE);
  if(Result != true) 
  { 
    Error = GetLastError(); 
    Print("CloseFirstOrderBuy: LastError = ",Error); 
  }  
  return;
}
//------------------------
void CloseFirstOrderSell()
{
  bool Result;
  int  ticket = 0;

  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_SELL)
            if(ticket == 0)
            {
              ticket = OrderTicket();
              continue;
            }
            if(OrderTicket() < ticket)
              ticket = OrderTicket();
  RefreshRates();
  Result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),Slippage,CLR_NONE);
  if(Result != true) 
  { 
    Error = GetLastError(); 
    Print("CloseFirstOrderBuy: LastError = ",Error); 
  }  
  return;
}
//---------------------
double FindLastLotBuy()
{ 
  int ticket = 0;
  double lot = 0;    
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderType() == OP_BUY)
          if(OrderMagicNumber() == MN) 
            if(OrderTicket() > ticket)
            {
              ticket = OrderTicket();
              lot = OrderLots();
            }
  if(Debug) Print("LastLotBuy = ", lot);
  return(lot);
}
//----------------------
double FindLastLotSell()
{ 
  int ticket = 0;
  double lot = 0;    
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderType() == OP_SELL)
          if(OrderMagicNumber() == MN) 
            if(OrderTicket() > ticket)
            {
              ticket = OrderTicket();
              lot = OrderLots();
            }
  if(Debug) Print("LastLotSell = ", lot);
  return(lot);
}
//-----------------------
double FindLastBuyPrice()
{
  double LastBuyPrice;
  int LastBuyTicket;
  int ticket = 0;
  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType() == OP_BUY) 
          {
            LastBuyTicket = OrderTicket();
            if(LastBuyTicket > ticket) 
            {
              LastBuyPrice = OrderOpenPrice();
              ticket = LastBuyTicket;
            }
          }
//  if(Debug) Print("LastBuyPrice = ",LastBuyPrice);
  return(LastBuyPrice);
}
//------------------------
double FindLastSellPrice()
{
  double LastSellPrice;
  int LastSellTicket;
  int ticket = 0;
  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType() == OP_SELL) 
          {
            LastSellTicket = OrderTicket();
            if(LastSellTicket > ticket) 
            {
              LastSellPrice = OrderOpenPrice();
              ticket = LastSellTicket;
            }
          }
//  if(Debug) Print("LastSellPrice = ",LastSellPrice);
  return(LastSellPrice);
}
//--------------------------
void RecalculateTP(int Type)
{
  double NewTPPrice;
  if(Type == OP_BUY)
  {
    NewTPPrice = NormalizeDouble(CalculateAveragePriceBuy() + (TakeProfit * Point), Digits);
    for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType()== OP_BUY)
            if(OrderTakeProfit() != NewTPPrice)
              ModifyOrder(NewTPPrice);
  }
  if(Type == OP_SELL)
  {
    NewTPPrice = NormalizeDouble(CalculateAveragePriceSell() - (TakeProfit * Point), Digits);
    for (int j = 0; j < OrdersTotal(); j++) 
    if(OrderSelect(j, SELECT_BY_POS))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN) 
          if(OrderType()== OP_SELL)
            if(OrderTakeProfit() != NewTPPrice)
              ModifyOrder(NewTPPrice);
  }
  return;
}
//-------------------------------
double CalculateAveragePriceBuy()
{
  double Result = 0;
  double AveragePrice = 0;
  double Count = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_BUY) 
          {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
          }
  if(AveragePrice > 0 && Count > 0)
    Result = NormalizeDouble(AveragePrice / Count, Digits);
  return(Result);
}
//+------------------------------------------------------------------+
double CalculateAveragePriceSell()
{
  double Result = 0;
  double AveragePrice = 0;
  double Count = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN)
          if(OrderType() == OP_SELL) 
          {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
          }
  if(AveragePrice > 0 && Count > 0)
    Result = NormalizeDouble(AveragePrice / Count, Digits);
  return(Result);
}
//+------------------------------------------------------------------+
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  //if(Debug) Print(" SendMarketOrder");
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Error = ERR_TRADE_DISABLED;
      Print("!LET ME TRADE!");
      return(-1);
    }
    if(Debug) Print("  ");
    if(!IsConnected())
      Print("!NO CONNECTION!");
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      //Print("Trade Context Busy!");
      Sleep(3000);
      Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    if(Delay || (LastTickTime != MarketInfo(Symbol(),MODE_TIME))) 
    {
      //if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(),MODE_TIME);
      Delay = False;
    }
    else
    {
      //if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        Print("!INVALID ORDER TYPE!");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
     if (Err == 4 || /* SERVER_BUSY */
       Err == 128 || /* TRADE_TIMEOUT */  
       Err == 129 || /* INVALID_PRICE */ 
       Err == 135 || /* PRICE_CHANGED */ 
       Err == 136 || /* OFF_QUOTES */
       Err == 137 || /* BROKER_BUSY */ 
       Err == 138 || /* REQUOTE */
       Err == 146 /* TRADE_CONTEXT_BUSY */)
        {
          Print("!ERROR!(OrderSend - ", Err, "): ", ErrorDescription(Err));
          Print("Waiting 3 sec...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          Print("!CRITICAL ERROR!(OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      Print("!LET ME TRADE!");
      break;
    }
  }
  //if(Ticket > 0)
    //if(Debug) Print("Order sent OK, Ticket = ",Ticket);
  if(!(Ticket > 0))
    Print("!ERROR! ORDER NOT SENT! (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}
//---------------------------------------------------
bool ModifyOrder( double TakeProfit)
{
  if((OrderTakeProfit() == TakeProfit) && (OrderStopLoss() == 0))
    return(true);
  while(!IsStopped())
  {
    //if(Debug) Print("Function ModifyOrder");
    if(!IsTesting())
    {
      if(IsTradeContextBusy())
      {
        Print("Trade context busy, waiting 3 sec...");
        Sleep(3000);
        continue;
      }
      //if(Debug) Print("Trade context OK");
      if(!IsTradeAllowed())
      {
        Print("!LET ME TRADE!");
        Sleep(3000);
        continue;
      }
      //if(Debug) Print("Modifying Order # ",OrderTicket());
    }
    if(!OrderModify(OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble(TakeProfit, Digits), 0, Yellow))
    {
      Print("!ORDER MODIFICATION FAILED!");
      int Err = GetLastError();
      Print("Error(",Err,"): ",ErrorDescription(Err));
      break;
    }
    else
    {
      if(Debug) Print("Order Modification OK");
      break;
    }
  }
  return(true);
}
//--------------------
int GetSignal()
{
  int sig = 0;
  int num = NumberOfBars;
  int tf = mper[TF_Bars];
  double delta = PriceDistance;
  
  double Bar1_High = NormalizeDouble(iHigh(Symbol(), tf, 1), Digits);
  double Bar1_Low  = NormalizeDouble(iLow(Symbol(), tf, 1), Digits);
  double BarN_High = NormalizeDouble(iHigh(Symbol(), tf, num), Digits);
  double BarN_Low  = NormalizeDouble(iLow(Symbol(), tf, num), Digits);
  
  if(NormalizeDouble((Bar1_High - BarN_Low) / Point, 0) > delta) sig = -1;
  if(NormalizeDouble((BarN_High - Bar1_Low) / Point, 0) > delta) sig =  1;
  return(sig);
}

